package eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport;

import org.eclipse.core.resources.IMarker;
import org.eclipse.jface.text.Position;
import org.eclipse.jface.text.source.Annotation;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.RGB;

public class WarningAnnotation extends Annotation {
    private IMarker marker;
    private String text;
    private int line;
    private Position position;

    // error identifiers, images and colors
    public static String WARNING_TYPE = "warning.type";
    public static Image WARNING_IMAGE;
    public static final RGB WARNING_RGB = new RGB(244, 200, 45);    
    
    public WarningAnnotation(IMarker marker) {
        this.marker = marker;
    }

    public WarningAnnotation(int line, String text) {
        super(WARNING_TYPE, true, null);
        this.marker = null;
        this.line = line;
        this.text = text;
    }

    public IMarker getMarker() {
        return marker;
    }

    public int getLine() {
        return line;
    }

    public String getText() {
        return text;
    }

    public Image getImage() {
        return WARNING_IMAGE;
    }

    public int getLayer() {
        return 3;
    }

    public String getType() {
        return WARNING_TYPE;
    }

    public Position getPosition() {
        return position;
    }

    public void setPosition(Position position) {
        this.position = position;
    }
}