// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.bulkeditor.handler;

import java.util.Iterator;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.text.TextSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.taxeditor.annotatedlineeditor.LineAnnotation;
import eu.etaxonomy.taxeditor.annotatedlineeditor.LineAnnotationModel;
import eu.etaxonomy.taxeditor.bulkeditor.BulkEditor;

/**
 * @author p.ciardelli
 * @created 25.06.2009
 * @version 1.0
 */
public class RemoveMergeCandidateHandler extends AbstractHandler {

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
				
		if (HandlerUtil.getCurrentSelection(event) instanceof TextSelection 
				&& HandlerUtil.getActiveEditor(event) instanceof BulkEditor) {
			TextSelection selection = (TextSelection) HandlerUtil.getCurrentSelection(event);
			BulkEditor editor = (BulkEditor) HandlerUtil.getActiveEditor(event);
			
			LineAnnotationModel model = (LineAnnotationModel) editor.getDocumentProvider().getAnnotationModel(editor.getEditorInput());
			if (model != null) {
				Iterator iter = model.getAnnotationIterator(selection.getOffset(), selection.getLength(), true, true);
				while (iter.hasNext()) {
					Object next = iter.next();
					if (next instanceof LineAnnotation) {
						model.changeAnnotationType(
								(LineAnnotation) next, LineAnnotation.TYPE_GENERIC);
					}
				}
			}
		}	
		return null;
	}
}