/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.description.CommonTaxonName;
import eu.etaxonomy.taxeditor.forms.TextWithLabelComposite;
import eu.etaxonomy.taxeditor.forms.termcombos.LanguageComboComposite;

/**
 * @author nho
 *
 */
public class CommonNameSection extends AbstractDescriptionDetailSection{

	LanguageComboComposite languageCombo;
	TextWithLabelComposite commonName;
	
	/**
	 * @param parent
	 * @param page
	 * @param style
	 */
	public CommonNameSection(Composite parent,
			AbstractDescriptionDetailsPage page, int style) {
		super(parent, page, style);
		
		setText("Common Name Details");
		
		languageCombo = toolkit.createLanguageComboComposite(getClient(), "Language", null, SWT.WRAP);
		languageCombo.addPropertyChangeListener(this);
		languageCombo.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
		commonName = toolkit.createTextWithLabelComposite(getClient(), "Common Name", null, SWT.WRAP);
		commonName.addPropertyChangeListener(this);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#updateSection()
	 */
	@Override
	public void updateSection() {
		languageCombo.setSelection(getDescriptionElement().getLanguage());
		commonName.setText(getDescriptionElement().getName());
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent event) {
		super.propertyChange(event);
		getDescriptionElement().setName(commonName.getText());
		getDescriptionElement().setLanguage(languageCombo.getSelection());
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailSection#getDescriptionElement()
	 */
	@Override
	public CommonTaxonName getDescriptionElement() {
		return (CommonTaxonName) super.getDescriptionElement();
	}
}
