/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.name;

import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * @author p.ciardell
 * @created 22.12.2008
 * @version 1.0
 */
public interface INameEditorCompositeRepository {

	public Composite getAcceptedName();
	
	public Composite getSynonym(Synonym synonym);
	
	public Composite getHomotypicGroup(HomotypicalGroup group);
	
	public Composite getMisappliedName(Taxon misappliedName);
	
	public Composite getMisappliedGroup();
	
	public Composite getConcept(Taxon relatedConcept);
	
	public Composite getConceptGroup();
}
