/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.media.IdentifiableMediaEntity;
import eu.etaxonomy.cdm.model.media.Media;

/**
 * @author nho
 *
 */
public class MediaSection extends AbstractEntitySetSection<IdentifiableMediaEntity>{

	/**
	 * @param parent
	 * @param entity
	 * @param style
	 */
	protected MediaSection(Composite parent, IdentifiableMediaEntity entity,
			int style) {
		super(parent, entity, style);
		setText("Media");
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractEntitySetSection#createDynamicContents()
	 */
	@Override
	protected void createDynamicContents() {
		// TODO Auto-generated method stub
		
	}
	
	private class RemoveListener extends SelectionAdapter{
		private Media media;
		
		public RemoveListener(Media media){
			this.media = media;
		}
		
		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		@Override
		public void widgetSelected(SelectionEvent e) {
			getEntity().removeMedia(media);
			internalUpdateSection(true);
		}
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractEntitySetSection#getAddAction()
	 */
	@Override
	protected IAction getAddAction() {
		Action addMedia = new Action("add", Action.AS_PUSH_BUTTON){
			/* (non-Javadoc)
			 * @see org.eclipse.jface.action.Action#run()
			 */
			@Override
			public void run() {
				Media media = Media.NewInstance();
				getEntity().addMedia(media);
				internalUpdateSection(true);
				if(! getSection().isExpanded())
					getSection().setExpanded(true);
				internalUpdateSection(true);
			}
		};
		addMedia.setToolTipText("Create a new marker");
		return addMedia;
	}

}
