/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
import eu.etaxonomy.cdm.model.media.Rights;

/**
 * @author nho
 *
 */
public class RightsSection extends AbstractEntitySetSection<IdentifiableEntity> {

	/**
	 * @param parent
	 * @param entity
	 * @param style
	 */
	protected RightsSection(Composite parent, IdentifiableEntity entity,
			int style) {
		super(parent, entity, style);
		setText("Rights");
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractEntitySetSection#createDynamicContents()
	 */
	@Override
	protected void createDynamicContents() {
		// TODO Auto-generated method stub
		
	}
	
	private class RemoveListener extends SelectionAdapter{
		private Rights rights;
		
		public RemoveListener(Rights rights){
			this.rights = rights;
		}
		
		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		@Override
		public void widgetSelected(SelectionEvent e) {
			getEntity().removeRights(rights);
			internalUpdateSection(true);
		}
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractEntitySetSection#getAddAction()
	 */
	@Override
	protected IAction getAddAction() {
		Action addRights = new Action("add", Action.AS_PUSH_BUTTON){
			/* (non-Javadoc)
			 * @see org.eclipse.jface.action.Action#run()
			 */
			@Override
			public void run() {
				Rights rights = Rights.NewInstance();
				getEntity().addRights(rights);
				internalUpdateSection(true);
				if(! getSection().isExpanded())
					getSection().setExpanded(true);
				internalUpdateSection(true);
			}
		};
		addRights.setToolTipText("Create a new marker");
		return addRights;
	}

}
