// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.wizard;

import org.apache.log4j.Logger;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IImportWizard;

import eu.etaxonomy.cdm.io.common.CdmDefaultImport;
import eu.etaxonomy.cdm.io.common.IImportConfigurator;
import eu.etaxonomy.cdm.io.common.IIoConfigurator;
import eu.etaxonomy.taxeditor.datasource.wizard.NomenclaturalCodeWizardPage;

/**
 * @author n.hoffmann
 * @created 24.06.2009
 * @version 1.0
 */
public abstract class AbstractImportWizard<CONFIG extends IIoConfigurator> extends Wizard implements IImportWizard {
	private static final Logger logger = Logger
			.getLogger(AbstractImportWizard.class);
	
	protected final String CONFIGURATION_PAGE = "CONFIGURATION_PAGE"; 
	
	private GenericConfiguratorWizardPage pageConfiguration;
	private NomenclaturalCodeWizardPage pageNomenclaturalCode;
	
	private CdmDefaultImport<IImportConfigurator> importer;
	

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#addPages()
	 */
	@Override
	public void addPages() {
		super.addPages();
		
		pageConfiguration = GenericConfiguratorWizardPage.Import(CONFIGURATION_PAGE, getConfigurator());
		this.addPage(pageConfiguration);
		
		pageNomenclaturalCode = new NomenclaturalCodeWizardPage((IImportConfigurator)getConfigurator());
		this.addPage(pageNomenclaturalCode);
	}
	
	public abstract CONFIG getConfigurator();
}
