/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.model;

import java.util.HashSet;
import java.util.Set;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;

/**
 * @author n.hoffmann
 * @created 25.03.2009
 * @version 1.0
 */
public class TaxonHelper {
	private static final Logger logger = Logger
		.getLogger(TaxonHelper.class);
	
	
	/**
	 * TODO this method should be in cdm library
	 * 
	 * Example:
	 * TaxonA(fromTaxon) isOverlapping TaxonB(toTaxon) 
	 * 
	 * @param fromTaxon
	 * @param toTaxon
	 * @return
	 * @deprecated TODO this method should be in the library
	 */
	public static TaxonRelationship getRelationshipBetweenTwoTaxa(Taxon fromTaxon, Taxon toTaxon){
		Set<TaxonRelationship> relations = new HashSet<TaxonRelationship>();
		
		for(TaxonRelationship relation : fromTaxon.getRelationsFromThisTaxon()){
			if(relation.getToTaxon().equals(toTaxon)){
				relations.add(relation);
			}
		}
		
		if(relations.size() > 1){
			logger.warn("Found multiple relations between two taxa. Does this make sense?");
		}
		
		if(relations.size() == 0){
			logger.warn("No relations between the two given taxa");
			new Throwable("No relations between the two given taxa");
		}
		
		return relations.toArray(new TaxonRelationship[0])[0];
	}
}
