// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.user.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.taxeditor.user.view.UserManagerView;
import eu.etaxonomy.taxeditor.user.wizard.UserWizard;

/**
 * @author n.hoffmann
 * @created 02.07.2009
 * @version 1.0
 */
public class CreateUserHandler extends AbstractHandler {
	private static final Logger logger = Logger
			.getLogger(CreateUserHandler.class);

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		Shell shell = HandlerUtil.getActiveShell(event);
		
		UserManagerView part = (UserManagerView) HandlerUtil.getActivePart(event);
		UserWizard wizard = new UserWizard(part); 
		
		WizardDialog dialog = new WizardDialog(shell, wizard);
	    dialog.open();
		return null;
	}
}
